SystemOrganization addCategory: #iAddress!

WAComponent subclass: #ContactListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iAddress'!

!ContactListView methodsFor: 'rendering' stamp: 'WolfgangFischer 9/16/2019 17:01'!
addContact
    | name emailAddress |
    name := self request: 'Name'.
    emailAddress := self request: 'Email address'.
    Contact addContact: (Contact name: name emailAddress: emailAddress)! !

!ContactListView methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 17:03'!
removeContact: aContact
	(self confirm: 'Are you sure that you want to remove this contact?')
		ifTrue: [ Contact removeContact: aContact ]! !

!ContactListView methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 17:03'!
renderContact: aContact on: html
	html text: aContact name.
	html space.
	html anchor
		url: 'mailto:' , aContact emailAddress;
		with: aContact emailAddress.
	html text: ' ('.
	html anchor
		callback: [ self removeContact: aContact ];
		with: 'remove'.
	html text: ')'! !

!ContactListView methodsFor: 'rendering' stamp: 'WolfgangFischer 9/16/2019 17:00'!
renderContentOn: html
    html anchor
        callback: [ self addContact ];
        with: 'Add contact'.
    html unorderedList: [
        Contact contacts do: [ :contact |
            html listItem: [ self renderContact: contact on: html ] ] ]! !

Object subclass: #Contact
	instanceVariableNames: 'name emailAddress'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'iAddress'!

!Contact class methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 16:55'!
addContact: aContact
    self contacts add: aContact! !

!Contact class methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 16:55'!
contacts
    "Answers an OrderedCollection of the contact information instances."

    Database isNil ifTrue: [ self createSampleDatabase ].
    ^ Database! !

!Contact class methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 16:54'!
createSampleDatabase
    Database := OrderedCollection new
        add: (self name: 'Bob Jones' emailAddress: 'bob@nowhere.com');
        add: (self name: 'Steve Smith' emailAddress: 'sm@somewhere.com');
        yourself! !

!Contact class methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 16:53'!
name: nameString emailAddress: emailString
    ^ self new
          name: nameString;
          emailAddress: emailString;
          yourself! !

!Contact class methodsFor: 'as yet unclassified' stamp: 'WolfgangFischer 9/16/2019 16:55'!
removeContact: aContact
    self contacts remove: aContact! !

!Contact methodsFor: 'accessing' stamp: 'WolfgangFischer 9/16/2019 16:59'!
emailAddress
	^ emailAddress! !

!Contact methodsFor: 'accessing' stamp: 'WolfgangFischer 9/16/2019 16:59'!
emailAddress: anObject
	emailAddress := anObject! !

!Contact methodsFor: 'accessing' stamp: 'WolfgangFischer 9/16/2019 16:52'!
name1
	^ name! !

!Contact methodsFor: 'accessing' stamp: 'WolfgangFischer 9/16/2019 16:52'!
name: anObject
	name := anObject! !
